
/**
 * @file Echo.h
 *
 * $Id: Echo.h 76591 2007-01-25 18:17:52Z elliott_c $
 *
 * @author Carlos O'Ryan <coryan@atdesk.com>
 *
 */
#ifndef TAO_TESTS_BUG1270_ECHO_H
#define TAO_TESTS_BUG1270_ECHO_H

#include "ace/Atomic_Op.h"
#include "TestS.h"

class Echo : public POA_Test::Echo
{
public:
  Echo(CORBA::ORB_ptr orb,
       int abort_counter);

  virtual void echo_payload (Test::Payload const & data)
    ACE_THROW_SPEC((CORBA::SystemException));

  virtual void echo_payload_out (
        Test::Payload_out data
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
  CORBA::ORB_var orb_;

  ACE_Atomic_Op<ACE_SYNCH_MUTEX, int> abort_counter_;
};

#endif /* TAO_TESTS_BUG1270_ECHO_H*/
